Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.search.store
Interface IndexShardingStrategy

All Known Implementing Classes:
  IdHashShardingStrategy, NotShardedStrategy

    public interface IndexShardingStrategy

Defines how a given virtual index shards data into different DirectoryProviders

Author:
  Emmanuel Bernard

Method Summary
`DirectoryProvider<?>` | `getDirectoryProviderForAddition(java.lang.Class<?> entity, java.io.Serializable id, java.lang.String idInString, org.apache.lucene.document.Document document)` return the DirectoryProvider where the given entity will be indexed
`DirectoryProvider<?>[]` | `getDirectoryProvidersForAllShards()` Ask for all shards (eg to query or optimize)
`DirectoryProvider<?>[]` | `getDirectoryProvidersForDeletion(java.lang.Class<?> entity, java.io.Serializable id, java.lang.String idInString)` return the DirectoryProvider(s) where the given entity is stored and where the deletion operation needs to be applied id and idInString can be null.
`DirectoryProvider<?>[]` | `getDirectoryProvidersForQuery(FullTextFilterImplementor[] fullTextFilters)` return the set of DirectoryProvider(s) where the entities matching the filters are stored this optional optimization allows queries to hit a subset of all shards, which may be useful for some datasets if this optimization is not needed, return getDirectoryProvidersForAllShards() fullTextFilters can be empty if no filter is applied
`void` | `initialize(java.util.Properties properties, DirectoryProvider<?>[] providers)` provides access to sharding properties (under the suffix sharding_strategy) and provide access to all the DirectoryProviders for a given index

Method Detail

### initialize

    void initialize(java.util.Properties properties,
                    DirectoryProvider<?>[] providers)

  provides access to sharding properties (under the suffix sharding_strategy) and provide access to all the DirectoryProviders for a given index

### getDirectoryProvidersForAllShards

    DirectoryProvider<?>[] getDirectoryProvidersForAllShards()

  Ask for all shards (eg to query or optimize)

### getDirectoryProviderForAddition

    DirectoryProvider<?> getDirectoryProviderForAddition(java.lang.Class<?> entity,
                                                         java.io.Serializable id,
                                                         java.lang.String idInString,
                                                         org.apache.lucene.document.Document document)

  return the DirectoryProvider where the given entity will be indexed

### getDirectoryProvidersForDeletion

    DirectoryProvider<?>[] getDirectoryProvidersForDeletion(java.lang.Class<?> entity,
                                                            java.io.Serializable id,
                                                            java.lang.String idInString)

  return the DirectoryProvider(s) where the given entity is stored and where the deletion operation needs to be applied id and idInString can be null. If null, all the directory providers containing entity types should be returned

### getDirectoryProvidersForQuery

    DirectoryProvider<?>[] getDirectoryProvidersForQuery(FullTextFilterImplementor[] fullTextFilters)

  return the set of DirectoryProvider(s) where the entities matching the filters are stored this optional optimization allows queries to hit a subset of all shards, which may be useful for some datasets if this optimization is not needed, return getDirectoryProvidersForAllShards() fullTextFilters can be empty if no filter is applied

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2010 Hibernate. All Rights Reserved.